// JournalHook.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "JournalHook.h"
#include "JournalHookDlg.h"
#include "CmdLine.h"
#include "JournalRecorder.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "StringEx.h"

CString AfxMakeRelativePath(LPCTSTR pszFullPath, LPCTSTR pszCurrentPath)
{
	CStringEx szFullPath(pszFullPath), szCurrentPath(pszCurrentPath), szRelativePath(".");

	// On regarde si le debut n'est pas identique, alors on arrete
	if(!szFullPath.GetLength() || !szCurrentPath.GetLength() ||
		szFullPath.GetField('\\', 0).CompareNoCase(szCurrentPath.GetField('\\', 0)))
		szRelativePath = pszFullPath;
	else {
		int nEqualFiled = 1, i;

		while(szFullPath.GetField('\\', nEqualFiled).CompareNoCase(szCurrentPath.GetField('\\', nEqualFiled)) == 0)
			nEqualFiled++;

		if(szCurrentPath[szCurrentPath.GetLength() - 1] == '\\')
			szCurrentPath = szCurrentPath.Left(szCurrentPath.GetLength() - 1);

		if(szCurrentPath.GetFieldCount('\\') > nEqualFiled)
			for(i = 0; i < szCurrentPath.GetFieldCount('\\') - nEqualFiled; i++)
				szRelativePath += "\\..";

		if(szFullPath.GetFieldCount('\\') > nEqualFiled)
			for(i = 0; i < szFullPath.GetFieldCount('\\') - nEqualFiled; i++)
				szRelativePath += CString("\\") + szFullPath.GetField('\\', nEqualFiled + i);

		if(strncmp(szRelativePath, ".\\", 2) == 0)
			szRelativePath = szRelativePath.Mid(2);
	}

	return szRelativePath;
}

CString AfxMakeAbsolutePath(LPCTSTR pszRelativePath, LPCTSTR pszCurrentPath)
{
	CStringEx szFullPath, szCurrentPath(pszCurrentPath), szRelativePath(pszRelativePath);

	// ToDo

	return szFullPath = pszRelativePath;
}

CString AfxGetAppPath()
{
	return ((CJournalHookApp *)AfxGetApp())->m_szWorkingDirectory;
}

/////////////////////////////////////////////////////////////////////////////
// CJournalHookApp

BEGIN_MESSAGE_MAP(CJournalHookApp, CWinApp)
	//{{AFX_MSG_MAP(CJournalHookApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJournalHookApp construction

CJournalHookApp::CJournalHookApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CJournalHookApp object

CJournalHookApp theApp;
CCmdLine cmdLine;

CJournalHookDlg * AfxGetJournalHookDlg() { return (CJournalHookDlg *)AfxGetMainWnd(); }
CCmdLine * AfxGetCmdLine() { return &cmdLine; }

/////////////////////////////////////////////////////////////////////////////
// CJournalHookApp initialization

BOOL CJournalHookApp::InitInstance()
{
	char pszBuf[3000];
	::GetCurrentDirectory(sizeof(pszBuf) - 1, pszBuf);
	m_szWorkingDirectory = pszBuf;

	BOOL fPlayWithWindow = TRUE;

	// parse the command line
	// use __argc and __argv, in MFC apps
	if (cmdLine.SplitLine(__argc, __argv) >= 1)
	{
		if(AfxGetCmdLine()->HasSwitch("-h") || AfxGetCmdLine()->HasSwitch("-H") ||
			AfxGetCmdLine()->HasSwitch("-help") || AfxGetCmdLine()->HasSwitch("-HELP") ||
			AfxGetCmdLine()->HasSwitch("-?"))
			MessageBox(NULL, CString((LPCSTR)IDS_COMMANDLINE_HELP),
					CString((LPCSTR)IDS_COMMANDLINE_HELP_TITLE), MB_OK | MB_ICONINFORMATION);

		if(cmdLine.HasSwitch("-play")) {
			CString szReadFile;
			szReadFile = cmdLine.GetSafeArgument("-play", 0, NULL);

			char pszExtension[50];
			_splitpath(szReadFile, NULL, NULL, NULL, pszExtension);
			if(pszExtension) {

				AfxGetJournalRecorder()->EnableScreenSaver(FALSE);

				if(stricmp(pszExtension, CString(CString(".") + CString((LPCSTR)IDS_FILE_JOURNAL_EXTENSION))) == 0) {

					fPlayWithWindow = FALSE;
					AfxGetJournalRecorder()->Init(NULL);
					AfxGetJournalRecorder()->m_fPlayMode = MODE_JOURNAL;
					AfxGetJournalRecorder()->m_fLoopPlay = AfxGetCmdLine()->HasSwitch("-loop");
					AfxGetJournalRecorder()->m_fShakeMouse = AfxGetCmdLine()->HasSwitch("-shake");
					AfxGetJournalRecorder()->m_nShakeRange = atoi(AfxGetCmdLine()->GetSafeArgument("-shake", 0, "20"));

					AfxGetJournalRecorder()->LoadJournal(szReadFile);
					AfxGetJournalRecorder()->m_fIsRunning = TRUE;
					AfxGetJournalRecorder()->InstallFilter(JOURNAL_PLAYBACK_INDEX, TRUE);

				} else if(stricmp(pszExtension, CString(CString(".") + CString((LPCSTR)IDS_FILE_SCENARIO_EXTENSION))) == 0) {

					fPlayWithWindow = FALSE;

					AfxGetJournalRecorder()->Init(NULL);
					AfxGetJournalRecorder()->m_fPlayMode = MODE_SCENARIO;
					AfxGetJournalRecorder()->m_fShakeMouse = AfxGetCmdLine()->HasSwitch("-shake");
					AfxGetJournalRecorder()->m_nShakeRange = atoi(AfxGetCmdLine()->GetSafeArgument("-shake", 0, "20"));

					AfxGetJournalRecorder()->LoadScenario(szReadFile);
					AfxGetJournalRecorder()->RunScenario();
				}
			}
		}
	}

	if(fPlayWithWindow) {

		CJournalHookDlg dlg;
		m_pMainWnd = &dlg;
		dlg.DoModal();

	} else {

		MSG msg;
/*		while(AfxGetJournalRecorder()->m_fIsRunning && ::GetMessage(&msg, (HWND) NULL, 0, 0))  {
			if(msg.message == WM_CANCELJOURNAL)
				AfxGetJournalRecorder()->Stop();
			::TranslateMessage(&msg); 
			::DispatchMessage(&msg); 
		}
*/
		while(AfxGetJournalRecorder()->m_fIsRunning) {
			if(::PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
				if(msg.message == WM_CANCELJOURNAL)
					AfxGetJournalRecorder()->Stop();

				::TranslateMessage(&msg);
				::DispatchMessage(&msg);
			}
			::Sleep(10);
		}
	}

	AfxGetJournalRecorder()->EnableScreenSaver();

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}
