// JournalHookDlg.cpp : implementation file
//

#include "stdafx.h"
#include "JournalHook.h"
#include "JournalHookDlg.h"
#include "CmdLine.h"
#include "JournalRecorder.h"
#include "TimeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJournalHookDlg dialog

CJournalHookDlg::CJournalHookDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CJournalHookDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CJournalHookDlg)
	m_fLoopPlay = FALSE;
	m_fTopmost = FALSE;
	m_fShakeMouse = FALSE;
	m_nShakeRange = 0;
	m_fCheckAdvanced = FALSE;
	m_szEditStatus = _T("");
	m_fCheckIconize = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CJournalHookDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CJournalHookDlg)
	DDX_Control(pDX, IDC_SPIN2, m_wndSpinShakeRange);
	DDX_Control(pDX, IDC_STATIC_SCENARIO, m_wndStaticScenario);
	DDX_Control(pDX, IDC_EDIT_STATUS, m_wndEditStatus);
	DDX_Control(pDX, IDC_LIST_TIME, m_wndListBox);
	DDX_Control(pDX, IDC_STATIC_TOOLBAR_JOURNAL, m_stToolbarJournal);
	DDX_Control(pDX, IDC_STATIC_TOOLBAR_SCENARIO, m_stToolbarScenario);
	DDX_Check(pDX, IDC_CHECK_REPLAY, m_fLoopPlay);
	DDX_Check(pDX, IDC_CHECK_TOPMOST, m_fTopmost);
	DDX_Check(pDX, IDC_CHECK_SHAKE, m_fShakeMouse);
	DDX_Text(pDX, IDC_EDIT_SHAKE_RANGE, m_nShakeRange);
	DDV_MinMaxInt(pDX, m_nShakeRange, 0, 999);
	DDX_Check(pDX, IDC_CHECK_ADVANCED, m_fCheckAdvanced);
	DDX_Text(pDX, IDC_EDIT_STATUS, m_szEditStatus);
	DDX_Check(pDX, IDC_CHECK_ICONIZE, m_fCheckIconize);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CJournalHookDlg, CDialog)
	//{{AFX_MSG_MAP(CJournalHookDlg)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_JOURNAL_RECORD, OnButtonJournalRecord)
	ON_BN_CLICKED(IDC_BUTTON_JOURNAL_STOP, OnButtonJournalStop)
	ON_BN_CLICKED(IDC_BUTTON_JOURNAL_PLAY, OnButtonJournalPlay)
	ON_BN_CLICKED(IDC_BUTTON_JOURNAL_ERASE, OnButtonJournalErase)
	ON_BN_CLICKED(IDC_BUTTON_JOURNAL_LOAD, OnButtonJournalLoad)
	ON_BN_CLICKED(IDC_BUTTON_JOURNAL_SAVE, OnButtonJournalSave)
	ON_BN_CLICKED(IDM_ABOUTBOX, OnAboutbox)
	ON_COMMAND(IDC_BUTTON_SCENARIO_NEW, OnButtonScenarioNew)
	ON_COMMAND(IDC_BUTTON_SCENARIO_REMOVE, OnButtonScenarioRemove)
	ON_COMMAND(IDC_BUTTON_SCENARIO_PROPERTY, OnButtonScenarioProperty)
	ON_COMMAND(IDC_BUTTON_SCENARIO_UP, OnButtonScenarioUp)
	ON_COMMAND(IDC_BUTTON_SCENARIO_DOWN, OnButtonScenarioDown)
	ON_COMMAND(IDC_BUTTON_SCENARIO_LOAD, OnButtonScenarioLoad)
	ON_COMMAND(IDC_BUTTON_SCENARIO_MERGE, OnButtonScenarioMerge)
	ON_COMMAND(IDC_BUTTON_SCENARIO_SAVE, OnButtonScenarioSave)
	ON_COMMAND(IDC_BUTTON_SCENARIO_RUN, OnButtonScenarioRun)
	ON_COMMAND(IDC_BUTTON_SCENARIO_RUN_SELECTED, OnButtonScenarioRunSelected)
	ON_LBN_SELCHANGE(IDC_LIST_TIME, OnSelchangeListTime)
	ON_LBN_DBLCLK(IDC_LIST_TIME, OnDblclkListTime)
	ON_BN_CLICKED(IDC_CHECK_TOPMOST, OnCheckTopmost)
	ON_BN_CLICKED(IDC_CHECK_ADVANCED, OnCheckAdvanced)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(IDC_SELECT_ALL_JOURNAL, OnSelectAllJournal)
	//}}AFX_MSG_MAP

	// toolbar tooltip notification
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXTW, 0, 0xFFFF, OnToolTipText)
	ON_NOTIFY_EX_RANGE(TTN_NEEDTEXTA, 0, 0xFFFF, OnToolTipText)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CJournalHookDlg message handlers

BOOL CJournalHookDlg::OnInitDialog()
{
	TRACE("CJournalHookDlg::OnInitDialog\n");

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, FALSE);		// Set small icon
	SetIcon(m_hIcon, TRUE);			// Set big icon


	HINSTANCE hInst = AfxFindResourceHandle(m_lpszTemplateName, RT_ACCELERATOR);
	m_hAccelTable = ::LoadAccelerators(hInst, m_lpszTemplateName);


	CRect rect, rectToolBar;
	rectToolBar = CRect(0, 0, 0, 0);
	int nNbTool = m_wndToolBarJournal.GetCount();
	for(int i = 0; i < nNbTool; i++) {
		m_wndToolBarJournal.GetItemRect(i, &rect);
		rectToolBar |= rect;
	}

	m_stToolbarJournal.GetWindowRect(&rect);
	ScreenToClient(&rect);

	int nWidth = rectToolBar.Width();
	int nHeight = rectToolBar.Height();
	rectToolBar.left = rect.left; // + rect.Width() - nWidth;
	rectToolBar.right = rectToolBar.left + nWidth;
	rectToolBar.top = rect.top;
	rectToolBar.bottom = rectToolBar.top + nHeight;
	m_wndToolBarJournal.MoveWindow(rectToolBar, FALSE);


	rectToolBar = CRect(0, 0, 0, 0);
	nNbTool = m_wndToolBarScenario.GetCount();
	for(i = 0; i < nNbTool; i++) {
		m_wndToolBarScenario.GetItemRect(i, &rect);
		rectToolBar |= rect;
	}

	m_stToolbarScenario.GetWindowRect(&rect);
	ScreenToClient(&rect);

	nWidth = rectToolBar.Width();
	nHeight = rectToolBar.Height();
	rectToolBar.left = rect.left; // + rect.Width() - nWidth;
	rectToolBar.right = rectToolBar.left + nWidth;
	rectToolBar.top = rect.top;
	rectToolBar.bottom = rectToolBar.top + nHeight;
	m_wndToolBarScenario.MoveWindow(rectToolBar, FALSE);


	AfxGetJournalRecorder()->Init(CallBack);

	m_nHookIndex = -1;

	m_fLoopPlay = FALSE;

//	m_fCheckEveryday = AfxGetJournalRecorder()->m_fPlayEveryday;

	m_fLoopPlay = AfxGetCmdLine()->HasSwitch("-loop");

	GetWindowRect(&m_rectShowDlg);
	m_rectHideDlg = m_rectShowDlg;
	m_rectHideDlg.bottom = m_rectHideDlg.top + rectToolBar.top;
	m_fCheckAdvanced = FALSE;
	OnCheckAdvanced();

	m_fTopmost = TRUE;

	EnableToolTips(TRUE);

	m_wndSpinShakeRange.SetRange(0, 999);
	m_fShakeMouse = AfxGetCmdLine()->HasSwitch("-shake");
	m_nShakeRange = atoi(AfxGetCmdLine()->GetSafeArgument("-shake", 0, "20"));

	UpdateData(FALSE);
	UpdateToolBarJournal();
	UpdateToolBarScenario();

	SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	if(AfxGetCmdLine()->HasSwitch("-icon")) {
		ShowWindow(SW_MINIMIZE);
		UpdateWindow();
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CJournalHookDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX) {
		OnAboutbox();
	} else {
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CJournalHookDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CJournalHookDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CJournalHookDlg::OnButtonJournalRecord() 
{
	TRACE("CJournalHookDlg::OnButtonJournalRecord\n");

	UpdateData();
	if(m_fCheckIconize)
		ShowWindow(SW_MINIMIZE);

	AfxGetJournalRecorder()->EraseJournal();
	AfxGetJournalRecorder()->InstallFilter(m_nHookIndex = JOURNAL_RECORD_INDEX, TRUE);

	UpdateToolBarJournal();
}

void CJournalHookDlg::OnButtonJournalStop() 
{
	TRACE("CJournalHookDlg::OnButtonJournalStop\n");

	AfxGetJournalRecorder()->InstallFilter(m_nHookIndex, FALSE);

	UpdateToolBarJournal();

	m_nHookIndex = -1;
}

void CJournalHookDlg::OnButtonJournalPlay() 
{
	TRACE("CJournalHookDlg::OnButtonJournalPlay\n");

	UpdateData();

	AfxGetJournalRecorder()->EnableScreenSaver(FALSE);

	if(m_fCheckIconize)
		ShowWindow(SW_MINIMIZE);

	AfxGetJournalRecorder()->m_fShakeMouse = m_fShakeMouse;
	AfxGetJournalRecorder()->m_nShakeRange = m_nShakeRange;
	AfxGetJournalRecorder()->m_fLoopPlay = m_fLoopPlay;
	AfxGetJournalRecorder()->m_fPlayMode = MODE_JOURNAL;
	AfxGetJournalRecorder()->m_fIsRunning = TRUE;
	AfxGetJournalRecorder()->InstallFilter(m_nHookIndex = JOURNAL_PLAYBACK_INDEX, TRUE);

	UpdateToolBarJournal();
}

void CJournalHookDlg::OnDestroy() 
{
	TRACE("CJournalHookDlg::OnDestroy\n");

	CDialog::OnDestroy();
	
	AfxGetJournalRecorder()->InstallFilter(m_nHookIndex, FALSE);
}

void CJournalHookDlg::OnCheckTopmost() 
{
	TRACE("CJournalHookDlg::OnCheckTopmost\n");

	UpdateData();

	if(m_fTopmost)
		SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
	else
		SetWindowPos(&wndNoTopMost, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW);
}

void CJournalHookDlg::OnButtonJournalSave() 
{
	TRACE("CJournalHookDlg::OnButtonJournalSave\n");

	CFileDialog dlg(FALSE, CString((LPCSTR)IDS_FILE_JOURNAL_EXTENSION), NULL, OFN_EXPLORER | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
		CString((LPCSTR)IDS_FILE_JOURNAL), this);
	if(dlg.DoModal() == IDOK)
		AfxGetJournalRecorder()->SaveJournal(dlg.GetPathName());
}

void CJournalHookDlg::OnButtonJournalLoad() 
{
	TRACE("CJournalHookDlg::OnButtonJournalLoad\n");

	CFileDialog dlg(TRUE, CString((LPCSTR)IDS_FILE_JOURNAL_EXTENSION), NULL, OFN_EXPLORER | OFN_HIDEREADONLY,
		CString((LPCSTR)IDS_FILE_JOURNAL), this);
	if(dlg.DoModal() == IDOK)
		AfxGetJournalRecorder()->LoadJournal(dlg.GetPathName());

	UpdateToolBarJournal();
}

void CJournalHookDlg::OnButtonJournalErase() 
{
	TRACE("CJournalHookDlg::OnButtonJournalErase\n");

	AfxGetJournalRecorder()->EraseJournal();

	UpdateToolBarJournal();
}

int CJournalHookDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	TRACE("CJournalHookDlg::OnCreate\n");

	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBarJournal.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_ALIGN_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBarJournal.LoadToolBar(IDR_TOOLBAR_LIST_JOURNAL))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBarScenario.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_ALIGN_TOP
		| CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBarScenario.LoadToolBar(IDR_TOOLBAR_LIST_SCENARIO))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	
	return 0;
}

void CJournalHookDlg::UpdateToolBarJournal()
{
	TRACE("CJournalHookDlg::UpdateToolBarJournal\n");

//	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDC_BUTTON_JOURNAL_RECORD, TRUE);
	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDC_BUTTON_JOURNAL_STOP, AfxGetJournalRecorder()->IsRecording());
	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDC_BUTTON_JOURNAL_PLAY, !AfxGetJournalRecorder()->IsEmpty());
	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDC_BUTTON_JOURNAL_ERASE, !AfxGetJournalRecorder()->IsEmpty());
//	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDC_BUTTON_JOURNAL_LOAD, TRUE);
	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDC_BUTTON_JOURNAL_SAVE, !AfxGetJournalRecorder()->IsEmpty());
//	m_wndToolBarJournal.GetToolBarCtrl().EnableButton(IDM_ABOUTBOX, TRUE);
}

void CJournalHookDlg::UpdateToolBarScenario()
{
	TRACE("CJournalHookDlg::UpdateToolBarScenario\n");

//	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_NEW, TRUE);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_REMOVE, m_wndListBox.GetSelCount() > 0);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_PROPERTY, m_wndListBox.GetSelCount() == 1);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_UP, m_wndListBox.GetSelCount() > 0);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_DOWN, m_wndListBox.GetSelCount() > 0);
//	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_LOAD, TRUE);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_SAVE, m_wndListBox.GetCount() != 0);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_RUN_SELECTED, m_wndListBox.GetSelCount() > 0);
	m_wndToolBarScenario.GetToolBarCtrl().EnableButton(IDC_BUTTON_SCENARIO_RUN, m_wndListBox.GetCount() != 0);
}

LPCTSTR CJournalHookDlg::FormatListEntry(CJournalAction & a)
{
	TRACE("CJournalHookDlg::FormatListEntry\n");

	static CString szLine;

	CString szRepeat;
	if(a.m_fCheckRepeat)
		szRepeat.Format("%d", a.m_nEditRepeat);
	else
		szRepeat.Format("%d", a.m_tsDurationTime.GetTotalSeconds());

	szLine.Format("%s >> %s %s %s",
		a.m_szEditFile.GetLength() ? CString("...") + a.m_szEditFile.Right(18) : CString((LPCSTR)IDS_LIST_NOTHING_TO_DO),
		a.m_fCheckStart ? CString((LPCSTR)IDS_LIST_START_AT) + a.m_tStartTime.Format("%H:%M:%S") : "",
		a.m_fCheckRepeat ? CString((LPCSTR)IDS_LIST_REPEAT) + szRepeat : (a.m_fCheckDuration ? CString((LPCSTR)IDS_LIST_DURING) + szRepeat : ""),
		a.m_fCheckStop ? CString((LPCSTR)IDS_LIST_STOP_AT) + a.m_tStopTime.Format("%H:%M:%S") : "");

	return szLine;
}

void CJournalHookDlg::OnSelchangeListTime() 
{
	TRACE("CJournalHookDlg::OnSelchangeListTime\n");

	switch(m_wndListBox.GetSelCount()) {
	case 0:
		m_szEditStatus = "";
		break;
	case 1:
		m_szEditStatus = FormatListEntry(AfxGetJournalRecorder()->GetAt(m_wndListBox.GetCurSel()));
		break;
	default:
		m_szEditStatus.Format("%d journals selected", m_wndListBox.GetSelCount());
		break;
	}

	UpdateToolBarScenario();
	UpdateData(FALSE);
}

void CJournalHookDlg::OnButtonScenarioNew() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioNew\n");

	UpdateData();

	if(!m_fCheckAdvanced)
		return;

	CTimeDlg dlg;

	dlg.m_fCheckStart = FALSE;
	dlg.m_tStartTime = CTime(CTime::GetCurrentTime());

	dlg.m_fCheckRepeat = TRUE;
	dlg.m_nEditRepeat = 1;

	dlg.m_fCheckDuration = FALSE;
	dlg.m_tsDurationTime = CTimeSpan(0, 0, 1, 0);

	dlg.m_fCheckStop = FALSE;
	dlg.m_tStopTime = dlg.m_tStartTime;
	dlg.m_tStopTime += dlg.m_tsDurationTime;

	if(dlg.DoModal() == IDOK) {
		CJournalAction a;

		a.m_szEditFile = dlg.m_szEditFile;

		a.m_fCheckStart = dlg.m_fCheckStart;
		a.m_tStartTime = dlg.m_tStartTime;

		a.m_fCheckRepeat = dlg.m_fCheckRepeat;
		a.m_nEditRepeat = dlg.m_nEditRepeat;

		a.m_fCheckDuration = dlg.m_fCheckDuration;
		a.m_tsDurationTime = dlg.m_tsDurationTime;

		a.m_fCheckStop = dlg.m_fCheckStop;
		a.m_tStopTime = dlg.m_tStopTime;

		m_wndListBox.InsertString(AfxGetJournalRecorder()->Add(a), FormatListEntry(a));
	}

	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioRemove() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioRemove\n");

	UpdateData();
	if(!m_fCheckAdvanced || m_wndListBox.GetSelCount() == 0)
		return;

	int nItemCount = m_wndListBox.GetCount();
	for(int iItem = nItemCount - 1; iItem >= 0; iItem--) {
		if(m_wndListBox.GetSel(iItem) > 0) {
			m_wndListBox.DeleteString(iItem);
			AfxGetJournalRecorder()->RemoveAt(iItem);
		}
	}

	UpdateToolBarScenario();	
}

void CJournalHookDlg::OnDblclkListTime() 
{
	TRACE("CJournalHookDlg::OnDblclkListTime\n");

	if(m_wndListBox.GetSelCount() == 1)
		OnButtonScenarioProperty();
}

void CJournalHookDlg::OnButtonScenarioProperty() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioProperty\n");

	if(!m_fCheckAdvanced || m_wndListBox.GetSelCount() != 1)
		return;

	int nItem = m_wndListBox.GetCurSel();
	CJournalAction & a = AfxGetJournalRecorder()->ElementAt(nItem);

	CTimeDlg dlg;

	dlg.m_szEditFile = a.m_szEditFile;

	dlg.m_fCheckStart = a.m_fCheckStart;
	dlg.m_tStartTime = a.m_tStartTime;

	dlg.m_fCheckRepeat = a.m_fCheckRepeat;
	dlg.m_nEditRepeat = a.m_nEditRepeat;

	dlg.m_fCheckDuration = a.m_fCheckDuration;
	dlg.m_tsDurationTime = a.m_tsDurationTime;

	dlg.m_fCheckStop = a.m_fCheckStop;
	dlg.m_tStopTime = a.m_tStopTime;

	if(dlg.DoModal() == IDOK) {

		a.m_szEditFile = dlg.m_szEditFile;

		a.m_fCheckStart = dlg.m_fCheckStart;
		a.m_tStartTime = dlg.m_tStartTime;

		a.m_fCheckRepeat = dlg.m_fCheckRepeat;
		a.m_nEditRepeat = dlg.m_nEditRepeat;

		a.m_fCheckDuration = dlg.m_fCheckDuration;
		a.m_tsDurationTime = dlg.m_tsDurationTime;

		a.m_fCheckStop = dlg.m_fCheckStop;
		a.m_tStopTime = dlg.m_tStopTime;

		m_wndListBox.InsertString(nItem, FormatListEntry(a));
		m_wndListBox.DeleteString(nItem + 1);
		m_wndListBox.SetSel(nItem);
	}

	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioUp()
{
	TRACE("CJournalHookDlg::OnButtonScenarioUp\n");

	CString szLine;
	CJournalAction a;
	int nItemCount = m_wndListBox.GetCount();
	for(int iItem = 0; iItem < nItemCount; iItem++) {
		if(m_wndListBox.GetSel(iItem) > 0) {
			if(iItem == 0) break;
			m_wndListBox.GetText(iItem, szLine);
			m_wndListBox.DeleteString(iItem);
			m_wndListBox.InsertString(iItem - 1, szLine);
			a = AfxGetJournalRecorder()->GetAt(iItem);
			AfxGetJournalRecorder()->RemoveAt(iItem);
			AfxGetJournalRecorder()->InsertAt(iItem - 1, a);
			m_wndListBox.SetSel(iItem - 1);
		}
	}

	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioDown() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioDown\n");

	CString szLine;
	CJournalAction a;
	int nItemCount = m_wndListBox.GetCount();
	for(int iItem = nItemCount - 1; iItem >= 0; iItem--) {
		if(m_wndListBox.GetSel(iItem) > 0) {
			if(iItem == nItemCount - 1) break;
			m_wndListBox.GetText(iItem, szLine);
			m_wndListBox.DeleteString(iItem);
			m_wndListBox.InsertString(iItem + 1, szLine);
			a = AfxGetJournalRecorder()->GetAt(iItem);
			AfxGetJournalRecorder()->RemoveAt(iItem);
			AfxGetJournalRecorder()->InsertAt(iItem + 1, a);
			m_wndListBox.SetSel(iItem + 1);
		}
	}

	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioSave() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioSave\n");

	UpdateData();

	CFileDialog dlg(FALSE, CString((LPCSTR)IDS_FILE_SCENARIO_EXTENSION), NULL, OFN_EXPLORER | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
		CString((LPCSTR)IDS_FILE_SCENARIO), this);
	if(dlg.DoModal() == IDOK)
		AfxGetJournalRecorder()->SaveScenario(dlg.GetPathName());

	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioMerge() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioMerge\n");

	UpdateData();

	CFileDialog dlg(TRUE, CString((LPCSTR)IDS_FILE_SCENARIO_EXTENSION), NULL, OFN_EXPLORER | OFN_HIDEREADONLY,
		CString((LPCSTR)IDS_FILE_SCENARIO), this);
	if(dlg.DoModal() == IDOK) {
		CString szLine;
		while(m_wndListBox.GetCount()) m_wndListBox.DeleteString(0);
		AfxGetJournalRecorder()->MergeScenario(dlg.GetPathName());
		for(int iItem = 0; iItem < AfxGetJournalRecorder()->GetSize(); iItem++)
			m_wndListBox.InsertString(iItem, FormatListEntry(AfxGetJournalRecorder()->GetAt(iItem)));
	}

//	m_fCheckEveryday = AfxGetJournalRecorder()->m_fPlayEveryday;

	UpdateData(FALSE);
	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioLoad() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioLoad\n");

	UpdateData();

	CFileDialog dlg(TRUE, CString((LPCSTR)IDS_FILE_SCENARIO_EXTENSION), NULL, OFN_EXPLORER | OFN_HIDEREADONLY,
		CString((LPCSTR)IDS_FILE_SCENARIO), this);
	if(dlg.DoModal() == IDOK) {
		CString szLine;
		while(m_wndListBox.GetCount()) m_wndListBox.DeleteString(0);
		AfxGetJournalRecorder()->LoadScenario(dlg.GetPathName());
		for(int iItem = 0; iItem < AfxGetJournalRecorder()->GetSize(); iItem++)
			m_wndListBox.InsertString(iItem, FormatListEntry(AfxGetJournalRecorder()->GetAt(iItem)));
	}

//	m_fCheckEveryday = AfxGetJournalRecorder()->m_fPlayEveryday;

	UpdateData(FALSE);
	UpdateToolBarScenario();
}

void CJournalHookDlg::OnButtonScenarioRunSelected() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioRun\n");

	CByteArray anItemSelected;
	int nItemCount = m_wndListBox.GetCount();
	anItemSelected.SetSize(nItemCount);
	for(int iItem = 0; iItem < nItemCount; iItem++)
		anItemSelected[iItem] = m_wndListBox.GetSel(iItem) > 0;

	UpdateData();
	if(m_fCheckIconize)
		ShowWindow(SW_MINIMIZE);

	m_fRunSelectedScenario = TRUE;
	AfxGetJournalRecorder()->m_fShakeMouse = m_fShakeMouse;
	AfxGetJournalRecorder()->m_nShakeRange = m_nShakeRange;
	AfxGetJournalRecorder()->m_fPlayMode = MODE_SCENARIO;
	AfxGetJournalRecorder()->EraseJournal();

	UpdateToolBarJournal();

//	m_wndToolBarScenario.GetToolBarCtrl().PressButton(IDC_BUTTON_SCENARIO_RUN_SELECTED, TRUE);
	AfxGetJournalRecorder()->EnableScreenSaver(FALSE);
	AfxGetJournalRecorder()->RunScenario(anItemSelected);
}

void CJournalHookDlg::OnButtonScenarioRun() 
{
	TRACE("CJournalHookDlg::OnButtonScenarioRun\n");

	UpdateData();
	if(m_fCheckIconize)
		ShowWindow(SW_MINIMIZE);

	m_fRunSelectedScenario = FALSE;
	AfxGetJournalRecorder()->m_fShakeMouse = m_fShakeMouse;
	AfxGetJournalRecorder()->m_nShakeRange = m_nShakeRange;
	AfxGetJournalRecorder()->m_fPlayMode = MODE_SCENARIO;
	AfxGetJournalRecorder()->EraseJournal();

	AfxGetJournalHookDlg()->UpdateToolBarJournal();

//	m_wndToolBarScenario.GetToolBarCtrl().PressButton(IDC_BUTTON_SCENARIO_RUN, TRUE);
	AfxGetJournalRecorder()->EnableScreenSaver(FALSE);
	AfxGetJournalRecorder()->RunScenario();
}

void CJournalHookDlg::CallBack(int nType, LPARAM lStarted)
{
	TRACE("CJournalHookDlg::CallBack\n");

	switch(nType) {
	case JOURNAL_PLAYBACK_INDEX:
		if(!lStarted)
			AfxGetJournalHookDlg()->UpdateToolBarJournal();
		break;
	case JOURNAL_RECORD_INDEX:
		if(!lStarted)
			AfxGetJournalHookDlg()->UpdateToolBarJournal();
		break;

	case JOURNAL_MESSAGE:
		if(lStarted) {
			AfxGetJournalHookDlg()->m_szEditStatus = CString((LPCTSTR)lStarted);
			AfxGetJournalHookDlg()->UpdateData(FALSE);
		}
		break;
	case JOURNAL_LOAD:
		{
			for (int iItem = 0; iItem < AfxGetJournalHookDlg()->m_wndListBox.GetCount(); iItem++)
				AfxGetJournalHookDlg()->m_wndListBox.SetSel(iItem, lStarted == iItem);
			AfxGetJournalHookDlg()->UpdateToolBarScenario();
		}
		break;
	case SCENARIO_STOP_PLAYING:
//		AfxGetJournalHookDlg()->m_wndToolBarScenario.GetToolBarCtrl().PressButton(IDC_BUTTON_SCENARIO_RUN_SELECTED, FALSE);
//		AfxGetJournalHookDlg()->m_wndToolBarScenario.GetToolBarCtrl().PressButton(IDC_BUTTON_SCENARIO_RUN, FALSE);
		if(AfxGetJournalHookDlg()->m_fLoopPlay) {
			if(AfxGetJournalHookDlg()->m_fRunSelectedScenario)
				AfxGetJournalHookDlg()->OnButtonScenarioRunSelected();
			else
				AfxGetJournalHookDlg()->OnButtonScenarioRun();
		}
		break;
	case JOURNAL_STOP_RECORDING:
		AfxGetJournalHookDlg()->UpdateToolBarJournal();
		AfxGetJournalHookDlg()->UpdateData();
		if(AfxGetJournalHookDlg()->m_fCheckIconize)
			AfxGetJournalHookDlg()->ShowWindow(SW_RESTORE);
			
		break;
	}
}

void CJournalHookDlg::OnCheckAdvanced() 
{
	TRACE("CJournalHookDlg::OnCheckAdvanced\n");

	UpdateData();

	if(m_fCheckAdvanced) {
		SetWindowPos(NULL, 0, 0, m_rectShowDlg.Width(), m_rectShowDlg.Height(), SWP_NOMOVE);
		m_wndListBox.ShowWindow(SW_SHOW);
		m_wndToolBarScenario.ShowWindow(SW_SHOW);
//		m_wndCheckEveryday.ShowWindow(SW_SHOW);
		m_wndEditStatus.ShowWindow(SW_SHOW);
		m_wndStaticScenario.ShowWindow(SW_SHOW);
	} else {
		m_wndListBox.ShowWindow(SW_HIDE);
		m_wndToolBarScenario.ShowWindow(SW_HIDE);
//		m_wndCheckEveryday.ShowWindow(SW_HIDE);
		m_wndEditStatus.ShowWindow(SW_HIDE);
		m_wndStaticScenario.ShowWindow(SW_HIDE);
		SetWindowPos(NULL, 0, 0, m_rectHideDlg.Width(), m_rectHideDlg.Height(), SWP_NOMOVE);
	}
}

/*
void CJournalHookDlg::OnCheckEveryday() 
{
	TRACE("CJournalHookDlg::OnCheckEveryday\n");

	UpdateData();

//	AfxGetJournalRecorder()->m_fPlayEveryday = m_fCheckEveryday;
}
*/
BOOL CJournalHookDlg::OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult)
{
	ASSERT(pNMHDR->code == TTN_NEEDTEXTA || pNMHDR->code == TTN_NEEDTEXTW);

    #define _countof(array) (sizeof(array)/sizeof(array[0]))

	// allow top level routing frame to handle the message
//	if (GetRoutingFrame() != NULL)
//		return FALSE;

	// need to handle both ANSI and UNICODE versions of the message
	TOOLTIPTEXTA* pTTTA = (TOOLTIPTEXTA*)pNMHDR;
	TOOLTIPTEXTW* pTTTW = (TOOLTIPTEXTW*)pNMHDR;
	CString strTipText;
	UINT nID = pNMHDR->idFrom;

	if(pNMHDR->code == TTN_NEEDTEXTA && (pTTTA->uFlags & TTF_IDISHWND) ||
		pNMHDR->code == TTN_NEEDTEXTW && (pTTTW->uFlags & TTF_IDISHWND)) {

		// idFrom is actually the HWND of the tool
		nID = ::GetDlgCtrlID((HWND)nID);
	}

	if(nID != 0) {
        // Recherche ds le dico. du texte a afficher
		switch ( nID )
        {
			case IDC_BUTTON_JOURNAL_RECORD:		strTipText.LoadString(IDS_BUTTON_JOURNAL_RECORD); break;
			case IDC_BUTTON_JOURNAL_STOP:		strTipText.LoadString(IDS_BUTTON_JOURNAL_STOP); break;
			case IDC_BUTTON_JOURNAL_PLAY:		strTipText.LoadString(IDS_BUTTON_JOURNAL_PLAY); break;
			case IDC_BUTTON_JOURNAL_SAVE:		strTipText.LoadString(IDS_BUTTON_JOURNAL_SAVE); break;
			case IDC_BUTTON_JOURNAL_LOAD:		strTipText.LoadString(IDS_BUTTON_JOURNAL_LOAD); break;
			case IDC_BUTTON_JOURNAL_ERASE:		strTipText.LoadString(IDS_BUTTON_JOURNAL_ERASE); break;
			case IDM_ABOUTBOX:					strTipText.LoadString(IDS_ABOUTBOX); break;
			case IDC_CHECK_TOPMOST:				strTipText.LoadString(IDS_CHECK_TOPMOST); break;
			case IDC_CHECK_ICONIZE:				strTipText.LoadString(IDS_CHECK_ICONIZE); break;
			case IDC_CHECK_ADVANCED:			strTipText.LoadString(IDS_CHECK_ADVANCED); break;
			case IDC_CHECK_REPLAY:				strTipText.LoadString(IDS_CHECK_REPLAY); break;
			case IDC_CHECK_SHAKE:				strTipText.LoadString(IDS_CHECK_SHAKE); break;
			case IDC_EDIT_SHAKE_RANGE:			strTipText.LoadString(IDS_EDIT_SHAKE_RANGE); break;
//			case IDC_CHECK_EVERYDAY:			strTipText.LoadString(IDS_CHECK_EVERYDAY); break;
			case IDC_LIST_TIME:					strTipText.LoadString(IDS_LIST_TIME); break;
			case IDC_EDIT_STATUS:				strTipText.LoadString(IDS_EDIT_STATUS); break;
			case IDC_BUTTON_SCENARIO_NEW:		strTipText.LoadString(IDS_BUTTON_SCENARIO_NEW); break;
			case IDC_BUTTON_SCENARIO_REMOVE:	strTipText.LoadString(IDS_BUTTON_SCENARIO_REMOVE); break;
			case IDC_BUTTON_SCENARIO_PROPERTY:	strTipText.LoadString(IDS_BUTTON_SCENARIO_PROPERTY); break;
			case IDC_BUTTON_SCENARIO_UP:		strTipText.LoadString(IDS_BUTTON_SCENARIO_UP); break;
			case IDC_BUTTON_SCENARIO_DOWN:		strTipText.LoadString(IDS_BUTTON_SCENARIO_DOWN); break;
			case IDC_BUTTON_SCENARIO_LOAD:		strTipText.LoadString(IDS_BUTTON_SCENARIO_LOAD); break;
			case IDC_BUTTON_SCENARIO_MERGE:		strTipText.LoadString(IDS_BUTTON_SCENARIO_MERGE); break;
			case IDC_BUTTON_SCENARIO_SAVE:		strTipText.LoadString(IDS_BUTTON_SCENARIO_SAVE); break;
			case IDC_BUTTON_SCENARIO_RUN_SELECTED:	strTipText.LoadString(IDS_BUTTON_SCENARIO_RUN_SELECTED); break;
			case IDC_BUTTON_SCENARIO_RUN:		strTipText.LoadString(IDS_BUTTON_SCENARIO_RUN); break;
			default: break;
		}
    }

#ifndef _UNICODE
	if (pNMHDR->code == TTN_NEEDTEXTA)
		lstrcpyn(pTTTA->szText, strTipText, _countof(pTTTA->szText));
	else
		_mbstowcsz(pTTTW->szText, strTipText, _countof(pTTTW->szText));
#else
	if (pNMHDR->code == TTN_NEEDTEXTA)
		_wcstombsz(pTTTA->szText, strTipText, _countof(pTTTA->szText));
	else
		lstrcpyn(pTTTW->szText, strTipText, _countof(pTTTW->szText));
#endif
	*pResult = 0;

	// bring the tooltip window above other popup windows
	::SetWindowPos(pNMHDR->hwndFrom, HWND_TOP, 0, 0, 0, 0,
		SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOMOVE|SWP_NOOWNERZORDER);

	return TRUE;    // message was handled
}

void CJournalHookDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
/*	if(AfxGetJournalRecorder()->m_fIsRunning) {
		AfxGetJournalRecorder()->m_fIsRunning = FALSE;

		m_wndToolBarScenario.GetToolBarCtrl().PressButton(IDC_BUTTON_SCENARIO_RUN_SELECTED, FALSE);
		m_wndToolBarScenario.GetToolBarCtrl().PressButton(IDC_BUTTON_SCENARIO_RUN, FALSE);
	}
*/	
	CDialog::OnLButtonDown(nFlags, point);
}

void CJournalHookDlg::OnSelectAllJournal() 
{
	for(int i = 0;i < m_wndListBox.GetCount(); i++)
		m_wndListBox.SetSel(i);
}

BOOL CJournalHookDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg && pMsg->message == WM_CANCELJOURNAL) {
		TRACE("CJournalHookDlg::PreTranslateMessage WM_CANCELJOURNAL\n");
		AfxGetJournalRecorder()->Stop();
	}

	if(m_hAccelTable && pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST)
		return ::TranslateAccelerator(m_hWnd, m_hAccelTable, pMsg);
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CJournalHookDlg::OnAboutbox() 
{
	CAboutDlg dlgAbout;
	dlgAbout.DoModal();	
}
