// JournalHookDlg.h : header file
//

#if !defined(AFX_JOURNALHOOKDLG_H_INCLUDED_)
#define AFX_JOURNALHOOKDLG_H_INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CJournalAction;

/////////////////////////////////////////////////////////////////////////////
// CJournalHookDlg dialog

class CJournalHookDlg : public CDialog
{
// Construction
public:
	CJournalHookDlg(CWnd* pParent = NULL);	// standard constructor

	static void CallBack(int nType, LPARAM lParam);

// Dialog Data
	//{{AFX_DATA(CJournalHookDlg)
	enum { IDD = IDD_JOURNALHOOK_DIALOG };
	CSpinButtonCtrl	m_wndSpinShakeRange;
	CButton	m_wndStaticScenario;
	CEdit	m_wndEditStatus;
	CListBox	m_wndListBox;
	CStatic	m_stToolbarJournal;
	CStatic	m_stToolbarScenario;
	BOOL	m_fLoopPlay;
	BOOL	m_fTopmost;
	BOOL	m_fShakeMouse;
	int		m_nShakeRange;
	BOOL	m_fCheckAdvanced;
	CString	m_szEditStatus;
	BOOL	m_fCheckIconize;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJournalHookDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CToolTipCtrl m_tooltip;
	HICON m_hIcon;
	int m_nHookIndex;
	CRect m_rectShowDlg;
	CRect m_rectHideDlg;
	BOOL m_fRunSelectedScenario;

	CToolBar m_wndToolBarJournal;
	CToolBar m_wndToolBarScenario;
	void UpdateToolBarJournal();
	void UpdateToolBarScenario();
	LPCTSTR FormatListEntry(CJournalAction & a);

	HACCEL m_hAccelTable;

	// Generated message map functions
	//{{AFX_MSG(CJournalHookDlg)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonJournalRecord();
	afx_msg void OnButtonJournalStop();
	afx_msg void OnButtonJournalPlay();
	afx_msg void OnButtonJournalSave();
	afx_msg void OnButtonJournalLoad();
	afx_msg void OnButtonJournalErase();
	afx_msg void OnAboutbox();
	afx_msg void OnButtonScenarioNew();
	afx_msg void OnButtonScenarioRemove();
	afx_msg void OnButtonScenarioProperty();
	afx_msg void OnButtonScenarioUp();
	afx_msg void OnButtonScenarioDown();
	afx_msg void OnButtonScenarioLoad();
	afx_msg void OnButtonScenarioMerge();
	afx_msg void OnButtonScenarioSave();
	afx_msg void OnButtonScenarioRun();
	afx_msg void OnButtonScenarioRunSelected();
	afx_msg void OnCheckTopmost();
	afx_msg void OnCheckAdvanced();
	afx_msg void OnSelchangeListTime();
	afx_msg void OnDblclkListTime();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSelectAllJournal();
	//}}AFX_MSG
    afx_msg BOOL OnToolTipText(UINT, NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JOURNALHOOKDLG_H_INCLUDED_)
