// TimeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "JournalHook.h"
#include "TimeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTimeDlg dialog


CTimeDlg::CTimeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTimeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTimeDlg)
	m_fCheckDuration = FALSE;
	m_fCheckRepeat = FALSE;
	m_fCheckStart = FALSE;
	m_fCheckStop = FALSE;
	m_nEditRepeat = 0;
	m_szEditFile = _T("");
	//}}AFX_DATA_INIT
}


void CTimeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTimeDlg)
	DDX_Control(pDX, IDC_SPIN1, m_wndSpinRepeat);
	DDX_Control(pDX, IDC_EDIT_REPEAT, m_wndEditRepeat);
	DDX_Check(pDX, IDC_CHECK_DURATION, m_fCheckDuration);
	DDX_Check(pDX, IDC_CHECK_REPEAT, m_fCheckRepeat);
	DDX_Check(pDX, IDC_CHECK_START, m_fCheckStart);
	DDX_Check(pDX, IDC_CHECK_STOP, m_fCheckStop);
	DDX_Text(pDX, IDC_EDIT_REPEAT, m_nEditRepeat);
	DDV_MinMaxInt(pDX, m_nEditRepeat, 0, 10000);
	DDX_Text(pDX, IDC_EDIT_FILE, m_szEditFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTimeDlg, CDialog)
	//{{AFX_MSG_MAP(CTimeDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CHECK_START, OnCheckStart)
	ON_BN_CLICKED(IDC_CHECK_REPEAT, OnCheckRepeat)
	ON_BN_CLICKED(IDC_CHECK_DURATION, OnCheckDuration)
	ON_BN_CLICKED(IDC_CHECK_STOP, OnCheckStop)
	ON_BN_CLICKED(IDC_BUTTON_FILE, OnButtonFile)
	ON_BN_CLICKED(IDC_BUTTON_RELATIF, OnButtonRelatif)
	ON_BN_CLICKED(IDC_BUTTON_ABSOLUTE, OnButtonAbsolute)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTimeDlg message handlers

BOOL CTimeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	INITCOMMONCONTROLSEX InitCtrls;

	InitCtrls.dwSize=sizeof(INITCOMMONCONTROLSEX); 
	InitCtrls.dwICC=ICC_DATE_CLASSES;

	if ( ::InitCommonControlsEx(&InitCtrls) )
	{
		// Premiere zone de saisie pour l heure / date
		m_hWndStartDate = CreateCtrlDate(IDC_STATIC_START_DATE, IDC_EDIT_START_DATE, DTS_SHORTDATEFORMAT);
		m_hWndStartTime = CreateCtrlDate(IDC_STATIC_START_TIME, IDC_EDIT_START_TIME, DTS_TIMEFORMAT);

		// Deuxieme zone de saisie pour l heure
		m_hWndDurationTime = CreateCtrlDate(IDC_STATIC_DURATION_TIME, IDC_EDIT_DURATION_TIME, DTS_TIMEFORMAT);

		// Troisieme zone de saisie pour l heure / date
		m_hWndStopDate = CreateCtrlDate(IDC_STATIC_STOP_DATE, IDC_EDIT_START_DATE, DTS_SHORTDATEFORMAT);
		m_hWndStopTime = CreateCtrlDate(IDC_STATIC_STOP_TIME, IDC_EDIT_STOP_TIME, DTS_TIMEFORMAT);

		char lpLCDataDate [256];
		char lpLCDataTime [256];
		int cchDataDate = sizeof(lpLCDataDate);
		int cchDataTime = sizeof(lpLCDataTime);

		if( ::GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_SSHORTDATE, lpLCDataDate, cchDataDate) &&
			::GetLocaleInfo(LOCALE_USER_DEFAULT, LOCALE_STIMEFORMAT, lpLCDataTime, cchDataTime)) {

			DateTime_SetFormat(m_hWndStartDate, lpLCDataDate);
			DateTime_SetFormat(m_hWndStartTime, lpLCDataTime);
			DateTime_SetFormat(m_hWndDurationTime, lpLCDataTime);
			DateTime_SetFormat(m_hWndStopDate, lpLCDataDate);
			DateTime_SetFormat(m_hWndStopTime, lpLCDataTime);
		}

		SYSTEMTIME sSysTime;

		m_tStartTime.GetAsSystemTime(sSysTime);
		DateTime_SetSystemtime(m_hWndStartDate, GDT_VALID, &sSysTime);
		DateTime_SetSystemtime(m_hWndStartTime, GDT_VALID, &sSysTime);

		CTime t(CTime::GetCurrentTime());
		t = CTime(t.GetYear(), t.GetMonth(), t.GetDay(), 0, 0, 0);
		t += m_tsDurationTime;
		t.GetAsSystemTime(sSysTime);
		DateTime_SetSystemtime(m_hWndDurationTime, GDT_VALID, &sSysTime);

		m_tStopTime.GetAsSystemTime(sSysTime);
		DateTime_SetSystemtime(m_hWndStopDate, GDT_VALID, &sSysTime);
		DateTime_SetSystemtime(m_hWndStopTime, GDT_VALID, &sSysTime);
	}
	
	::EnableWindow(m_hWndStartDate, m_fCheckStart);
	::EnableWindow(m_hWndStartTime, m_fCheckStart);

	m_wndSpinRepeat.SetRange(0, 10000);
	m_wndEditRepeat.EnableWindow(m_fCheckRepeat);
	::EnableWindow(m_hWndDurationTime, m_fCheckDuration);

	::EnableWindow(m_hWndStopDate, m_fCheckStop);
	::EnableWindow(m_hWndStopTime, m_fCheckStop);

	UpdateData(FALSE);

	// Create the ToolTip control.
	m_tooltip.Create(this);
	m_tooltip.Activate(TRUE);
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_FILE), "Journal name");
	m_tooltip.AddTool(GetDlgItem(IDC_BUTTON_FILE), "Search a journal name");
	m_tooltip.AddTool(GetDlgItem(IDC_CHECK_START), "Set a journal start time and date");
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_START_DATE), "Set the journal start date");
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_START_TIME), "Set the journal start time");
	m_tooltip.AddTool(GetDlgItem(IDC_CHECK_REPEAT), "Repeat count the journal");
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_REPEAT), "The repeat count number (0: infinte repeat, 1 time, or N times");
	m_tooltip.AddTool(GetDlgItem(IDC_CHECK_DURATION), "Repeat during a period of time");
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_DURATION_TIME), "Repeat periode time");
	m_tooltip.AddTool(GetDlgItem(IDC_CHECK_STOP), "Set a journal stop time and date");
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_STOP_DATE), "Set the journal stop date");
	m_tooltip.AddTool(GetDlgItem(IDC_EDIT_STOP_TIME), "Set the journal stop time");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void GetRectStatic(CWnd *pWnd, UINT nID, CRect& rect)
{
	CStatic *pStatic=(CStatic *)pWnd->GetDlgItem(nID);

	rect=CRect(0,0,0,0);

	if ( pStatic!=NULL )
	{
		pStatic->GetClientRect(&rect);
		pStatic->MapWindowPoints(pWnd, &rect);
	}
}

HWND CTimeDlg::CreateCtrlDate(UINT nIDStatic, UINT nID, DWORD dwStyle)
{
    HWND hCtrl = NULL;
    CRect rect;

    ::GetRectStatic(this, nIDStatic, rect);
	hCtrl = ::CreateWindowEx(0,
                             DATETIMEPICK_CLASS, "DateTime",
                             WS_TABSTOP | WS_CHILD | WS_VISIBLE | dwStyle,
                             rect.left, rect.top, rect.Width(), rect.Height(),
                             m_hWnd, NULL, 
                             AfxGetApp()->m_hInstance, NULL);

	if ( hCtrl!=NULL )
        GetDlgItem(nID)->ShowWindow( SW_HIDE );

    return hCtrl;
}


void CTimeDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // Destruction des zones de saisie des dates / heures
    if(::IsWindow(m_hWndStartDate)) ::DestroyWindow(m_hWndStartDate);
    if(::IsWindow(m_hWndStartTime)) ::DestroyWindow(m_hWndStartTime);
    if(::IsWindow(m_hWndDurationTime)) ::DestroyWindow(m_hWndDurationTime);
    if(::IsWindow(m_hWndStopDate)) ::DestroyWindow(m_hWndStopDate);
    if(::IsWindow(m_hWndStopTime)) ::DestroyWindow(m_hWndStopTime);
}

BOOL CTimeDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	NMHDR * pNMHDR = (NMHDR *)lParam;

	if(pNMHDR->code == DTN_DATETIMECHANGE) {

        SYSTEMTIME sSysDate, sSysTime;

		// Recuperation de la valeur de la date
		if(DateTime_GetSystemtime(m_hWndStartDate, &sSysDate) == GDT_VALID &&
		   DateTime_GetSystemtime(m_hWndStartTime, &sSysTime) == GDT_VALID)
			m_tStartTime = CTime(sSysDate.wYear, sSysDate.wMonth, sSysDate.wDay, sSysTime.wHour, sSysTime.wMinute, sSysTime.wSecond);

		if(DateTime_GetSystemtime(m_hWndDurationTime, &sSysTime) == GDT_VALID)
			m_tsDurationTime = CTimeSpan(sSysDate.wDay = 0, sSysTime.wHour, sSysTime.wMinute, sSysTime.wSecond);

		if(DateTime_GetSystemtime(m_hWndStopDate, &sSysDate) == GDT_VALID &&
		   DateTime_GetSystemtime(m_hWndStopTime, &sSysTime) == GDT_VALID)
			m_tStopTime = CTime(sSysDate.wYear, sSysDate.wMonth, sSysDate.wDay, sSysTime.wHour, sSysTime.wMinute, sSysTime.wSecond);
	}

	*pResult = 0;

	return CDialog::OnNotify(wParam, lParam, pResult);
}

void CTimeDlg::OnCheckStart() 
{
	UpdateData();

	::EnableWindow(m_hWndStartDate, m_fCheckStart);
	::EnableWindow(m_hWndStartTime, m_fCheckStart);
}

void CTimeDlg::OnCheckRepeat() 
{
	UpdateData();

	m_wndEditRepeat.EnableWindow(m_fCheckRepeat);
	::EnableWindow(m_hWndDurationTime, m_fCheckDuration);
}

void CTimeDlg::OnCheckDuration() 
{
	UpdateData();

	m_wndEditRepeat.EnableWindow(m_fCheckRepeat);
	::EnableWindow(m_hWndDurationTime, m_fCheckDuration);
}

void CTimeDlg::OnCheckStop() 
{
	UpdateData();

	::EnableWindow(m_hWndStopDate, m_fCheckStop);
	::EnableWindow(m_hWndStopTime, m_fCheckStop);
}

void CTimeDlg::OnButtonFile() 
{
	CFileDialog dlg(TRUE, "mdz", NULL, OFN_EXPLORER | OFN_HIDEREADONLY,
		"Macro Dollar Journal Files (*.mdj)|*.mdj|All Files (*.*)|*.*||", this);
	if(dlg.DoModal() == IDOK) {
		m_szEditFile = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

BOOL CTimeDlg::PreTranslateMessage(MSG* pMsg)
{
	// Let the ToolTip process this message.
	m_tooltip.RelayEvent(pMsg);

	return CDialog::PreTranslateMessage(pMsg);	// CG: This was added by the ToolTips component.
}

void CTimeDlg::OnButtonRelatif() 
{
	m_szEditFile = AfxMakeRelativePath(m_szEditFile, AfxGetAppPath());
	UpdateData(FALSE);
}

void CTimeDlg::OnButtonAbsolute() 
{
	m_szEditFile = AfxMakeAbsolutePath(m_szEditFile, AfxGetAppPath());
	UpdateData(FALSE);	
}
